/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * SPACE-INVADERS
 * @author: NICULAESCU OANA (331CB)
 *********************************************************************************/

#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>

#include "lcd.h"

int poz = 0;
int bpoz = 0;
int kill = 0;
int moves = 0;
int boolean[16]; //retinem daca am sters caracterul sau nu, nu putem sa omoram ceva ce nu e acolo
unsigned char _instr_invader, _instr_nava;

//fa daca te muti la dreapta sa aduni +1 si daca te muti la stanga sa scazi -1 din poz, astfel aflii
// sub ce porcarie de sus te afli si poti sa il omori
// converteste pozitia celui de sus astfel 0x80+poz, daca poz < 10 si 0xA,0XB, 0XC etc daca poz >= 10
// atunci cand impusca suprascrie imaginea curenta cu imaginea cand impusca el si distruge invaderul de deasupra
// Buttons initialization.

char ButtonPressed(int buttonNumber, unsigned char pinOfButton, unsigned char portBit, int confidenceLevel);

char Pressed[numberOfButtons];
int Pressed_Confidence_Level[numberOfButtons]; //Measure button press cofidence
int Released_Confidence_Level[numberOfButtons]; //Measure button release confidence

char ButtonPressed(int buttonNumber, unsigned char pinOfButton, unsigned char portBit, int confidenceLevel)
{
	if (bit_is_clear(pinOfButton, portBit))
	{
		Pressed_Confidence_Level[buttonNumber] ++; //Increase Pressed Conficence
		Released_Confidence_Level[buttonNumber] = 0; //Reset released button confidence since there is a button press
		if (Pressed_Confidence_Level[buttonNumber] > confidenceLevel) //Indicator of good button press
		{
			if (Pressed[buttonNumber] == 0)
			{
				Pressed[buttonNumber] = 1;
				return 1;
			}
			//Zero it so a new pressed condition can be evaluated
			Pressed_Confidence_Level[buttonNumber] = 0;
		}
	} else
	{
		Released_Confidence_Level[buttonNumber] ++; //This works just like the pressed
		Pressed_Confidence_Level[buttonNumber] = 0; //Reset pressed button confidence since the button is released
		if (Released_Confidence_Level[buttonNumber] > confidenceLevel)
		{
			Pressed[buttonNumber] = 0;
			Released_Confidence_Level[buttonNumber] = 0;
		}
	}
	
	return 0;
}


void printSpaceCraft(unsigned char _instruction)
{
	LCD_writeInstruction(_instruction);
	LCD_writeData(0x01);
}

void printShooting(unsigned char _instruction)
{
	LCD_writeInstruction(_instruction);
	LCD_writeData(0x02);
}

void printDead(unsigned char _instruction)
{
	LCD_writeInstruction(_instruction);
	LCD_writeData(0x03);
}

void action()
{
	
	if (bpoz == 0 && poz == 1)
	{
		printDead(0xC0);
		printSpaceCraft(0xC1);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 0 && poz == -1)
	{
		poz = 0;
		return;
		
	}
	if (bpoz == 1 && poz == 2)
	{
		printDead(0xC1);
		printSpaceCraft(0xC2);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 1 && poz == 0)
	{
		printDead(0xC1);
		printSpaceCraft(0xC0);
		moves = moves + 1;
		return;
		
	}
	if (bpoz == 2 && poz == 3)
	{
		printDead(0xC2);
		printSpaceCraft(0xC3);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 2 && poz == 1)
	{
		printDead(0xC2);
		printSpaceCraft(0xC1);
		moves = moves + 1;
		return;
		
	}
	if (bpoz == 3 && poz == 4)
	{
		printDead(0xC3);
		printSpaceCraft(0xC4);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 3 && poz == 2)
	{
		printDead(0xC3);
		printSpaceCraft(0xC2);
		moves = moves + 1;
		return;
	}
	if (bpoz == 4 && poz == 5)
	{
		printDead(0xC4);
		printSpaceCraft(0xC5);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 4 && poz == 3)
	{
		printDead(0xC4);
		printSpaceCraft(0xC3);
		moves = moves + 1;
		return;
	}
	if (bpoz == 5 && poz == 6)
	{
		printDead(0xC5);
		printSpaceCraft(0xC6);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 5 && poz == 4)
	{
		printDead(0xC5);
		printSpaceCraft(0xC4);
		moves = moves + 1;
		return;		
	}
	if (bpoz == 6 && poz == 7)
	{
		printDead(0xC6);
		printSpaceCraft(0xC7);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 6 && poz == 5)
	{
		printDead(0xC6);
		printSpaceCraft(0xC5);
		moves = moves + 1;
		return;		
	}
	if (bpoz == 7 && poz == 8)
	{
		printDead(0xC7);
		printSpaceCraft(0xC8);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 7 && poz == 6)
	{
		printDead(0xC7);
		printSpaceCraft(0xC6);
		moves = moves + 1;
		return;		
	}
	if (bpoz == 8 && poz == 9)
	{
		printDead(0xC8);
		printSpaceCraft(0xC9);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 8 && poz == 7)
	{
		printDead(0xC8);
		printSpaceCraft(0xC7);
		moves = moves + 1;
		return;		
	}
	if (bpoz == 9 && poz == 10)
	{
		printDead(0xC9);
		printSpaceCraft(0xCA);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 9 && poz == 8)
	{
		printDead(0xC9);
		printSpaceCraft(0xC8);
		moves = moves + 1;
		return;
	}
	if (bpoz == 10 && poz == 11)
	{
		printDead(0xCA);
		printSpaceCraft(0xCB);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 10 && poz == 9)
	{
		printDead(0xCA);
		printSpaceCraft(0xC9);
		moves = moves + 1;
		return;
	}
	if (bpoz == 11 && poz == 12)
	{
		printDead(0xCB);
		printSpaceCraft(0xCC);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 11 && poz == 10)
	{
		printDead(0xCB);
		printSpaceCraft(0xCA);
		moves = moves + 1;
		return;
	}
	if (bpoz == 12 && poz == 13)
	{
		printDead(0xCC);
		printSpaceCraft(0xCD);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 12 && poz == 11)
	{
		printDead(0xCC);
		printSpaceCraft(0xCB);
		moves = moves + 1;
		return;
	}
	if (bpoz == 13 && poz == 14)
	{
		printDead(0xCD);
		printSpaceCraft(0xCE);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 13 && poz == 12)
	{
		printDead(0xCD);
		printSpaceCraft(0xCC);
		moves = moves + 1;
		return;
	}
	if (bpoz == 14 && poz == 15)
	{
		printDead(0xCE);
		printSpaceCraft(0xCF);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 14 && poz == 13)
	{
		printDead(0xCE);
		printSpaceCraft(0xCD);
		moves = moves + 1;
		return;
	}
	if (bpoz == 15 && poz == 16)
	{
		poz = 15;
		printSpaceCraft(0xCF);
		moves = moves + 1;
		return;
	} 
	if (bpoz == 15 && poz == 14)
	{
		printDead(0xCF);
		printSpaceCraft(0xCE);
		moves = moves + 1;
		return;
	}
}

void putDead()
{
	if (poz == 0)
	{
		printDead(0x80);
		LCD_print('m');
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 1)
	{
		printDead(0x81);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
		
	}
	if (poz == 2)
	{
		printDead(0x82);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	} 
	if (poz == 3)
	{
		printDead(0x83);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
		
	}
	if (poz == 4)
	{
		printDead(0x84);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	} 
	if (poz == 5)
	{
		printDead(0x85);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 6)
	{
		printDead(0x86);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 7)
	{
		printDead(0x87);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 8)
	{
		printDead(0x88);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 9)
	{
		printDead(0x89);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 10)
	{
		printDead(0x8A);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 11)
	{
		printDead(0x8B);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 12)
	{
		printDead(0x8C);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 13)
	{
		printDead(0x8D);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 14)
	{
		printDead(0x8E);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	if (poz == 15)
	{
		printDead(0x8F);
		if (boolean[poz] == 1)
		{
			kill = kill + 1;
			boolean[poz] = 0;
		}
		return;
	}
	
}

void clearSpaceCraft()
{
	if (poz == 0)
	{
		printDead(0xC0);
		LCD_print('m');
		return;
	} 
	if (poz == 1)
	{
		printDead(0xC1);
		return;
		
	}
	if (poz == 2)
	{
		printDead(0xC2);
		return;
	} 
	if (poz == 3)
	{
		printDead(0xC3);
		return;
		
	}
	if (poz == 4)
	{
		printDead(0xC4);
		return;
	} 
	if (poz == 5)
	{
		printDead(0xC5);
		return;
	}
	if (poz == 6)
	{
		printDead(0xC6);
		return;
	}
	if (poz == 7)
	{
		printDead(0xC7);
		return;
	}
	if (poz == 8)
	{
		printDead(0xC8);
		return;
	}
	if (poz == 9)
	{
		printDead(0xC9);
		return;
	}
	if (poz == 10)
	{
		printDead(0xCA);
		return;
	}
	if (poz == 11)
	{
		printDead(0xCB);
		return;
	}
	if (poz == 12)
	{
		printDead(0xCC);
		return;
	}
	if (poz == 13)
	{
		printDead(0xCD);
		return;
	}
	if (poz == 14)
	{
		printDead(0xCE);
		return;
	}
	if (poz == 15)
	{
		printDead(0xCF);
		return;
	}
}

//Check what kinda action we should take if one of the buttons is pressed
void checkButton(int *direction)
{
//	char buf[10] = "";

	if (ButtonPressed(1, PIND, 3, 100))
	{
		*direction = LEFT;
		bpoz = poz;
		poz = poz + *direction;
		action();
		return;
	}
		
	if (ButtonPressed(2, PIND, 4, 100))
	{
		*direction = RIGHT;
		bpoz = poz;
		poz = poz + *direction;
		action();
		return;
	}

	if (ButtonPressed(3, PIND, 5, 100))
	{
		*direction = SHOOT;
		putDead();
		return;
	}
}


/*	Afisare caracter custom 	*/
void printCustomChar()
{
	
	LCD_writeInstruction(0x40);
	
	LCD_writeData(0x04);
	LCD_writeData(0x0E);
	LCD_writeData(0x15);
	LCD_writeData(0x1F);
	LCD_writeData(0x1F);
	LCD_writeData(0x0E);
	LCD_writeData(0x0A);
	LCD_writeData(0x11);

	LCD_writeData(0x00);
	LCD_writeData(0x11);
	LCD_writeData(0x1F);
	LCD_writeData(0x0E);
	LCD_writeData(0x04);
	LCD_writeData(0x0E);
	LCD_writeData(0x1B);
	LCD_writeData(0x0A);
	
	
	LCD_writeData(0x04);
	LCD_writeData(0x11);
	LCD_writeData(0x1F);
	LCD_writeData(0x0E);
	LCD_writeData(0x04);
	LCD_writeData(0x0E);
	LCD_writeData(0x1B);
	LCD_writeData(0x0A);
	
	LCD_writeData(0x00);
	LCD_writeData(0x00);
	LCD_writeData(0x00);
	LCD_writeData(0x00);
	LCD_writeData(0x00);
	LCD_writeData(0x00);
	LCD_writeData(0x00);
	LCD_writeData(0x00);

	LCD_writeInstruction(0x80);
	LCD_writeData(0x00);
	
	LCD_writeInstruction(0x81);	
	LCD_writeData(0x00);

	LCD_writeInstruction(0x82);	
	LCD_writeData(0x00);

	LCD_writeInstruction(0x83);	
	LCD_writeData(0x00);
	
	LCD_writeInstruction(0x84);	
	LCD_writeData(0x00);

	LCD_writeInstruction(0x85);
	LCD_writeData(0x00);
	
	LCD_writeInstruction(0x86);	
	LCD_writeData(0x00);

	LCD_writeInstruction(0x87);	
	LCD_writeData(0x00);

	LCD_writeInstruction(0x88);	
	LCD_writeData(0x00);
	
	LCD_writeInstruction(0x89);	
	LCD_writeData(0x00);
	
	LCD_writeInstruction(0x8A);
	LCD_writeData(0x00);
	
	LCD_writeInstruction(0x8B);	
	LCD_writeData(0x00);

	LCD_writeInstruction(0x8C);	
	LCD_writeData(0x00);

	LCD_writeInstruction(0x8D);	
	LCD_writeData(0x00);
	
	LCD_writeInstruction(0x8E);	
	LCD_writeData(0x00);
	
	LCD_writeInstruction(0x8F);	
	LCD_writeData(0x00);
}

void task4()
{
	printCustomChar();
	printSpaceCraft(0xC0);	
}

void check_kill()
{
	char buf[30]="";

	if (kill == 16)
	{
		kill = 0;
		clearSpaceCraft();
		sprintf(buf, "Numar de mutari");
		LCD_writeInstruction(0X80);
		LCD_print(buf);
		LCD_writeInstruction(LCD_INSTR_nextLine);
		buf[30]="";
		sprintf(buf, "======%d======", moves);
		LCD_print(buf);
	}	
	return;
}

int main()
{

	int i;
	
	DDRD = 0b00000000;
	PORTD = (1 << PIND2)|(1 << PIND3)|(1 << PIND4)|(1 << PIND5);
	
	for (i=0; i < 16; i += 1)
	{
		boolean[i] = 1;
	}

	LCD_init();
	task4();
	int dir = -2;

	while(1)
	{
		checkButton(&dir);
		check_kill();
	}
	return 0;
}
